import {createRoute, OpenAPIHono, z} from "@hono/zod-openapi";
import {authMiddleware} from "../../auth/middleware/authMiddleware.js";
import {apiHit} from "../../../globalUtils/apiHits.js";
import {closePool} from "../prodSqlServer.js";

const app = new OpenAPIHono();

const responseSchema = z.object({
    success: z.boolean().openapi({example: true}),
    message: z.string().optional().openapi({example: "user access"}),
});

app.openapi(
    createRoute({
        tags: ["Server:PRODSQL"],
        summary: "Close connection",
        method: "get",
        path: "/",
        middleware: authMiddleware,
        description: "Closes the connection to the prod sql server.",
        responses: {
            200: {
                content: {"application/json": {schema: responseSchema}},
                description: "stopped",
            },
            400: {
                content: {"application/json": {schema: responseSchema}},
                description: "Failed to stop",
            },
        },
    }),
    async (c) => {
        apiHit(c, {endpoint: "api/sqlProd/close"});

        try {
            const pool = await closePool();
            //return apiReturn(c, true, access?.message, access?.data, 200);
            return c.json({success: pool.success, message: pool.message}, 200);
        } catch (error) {
            console.log(error);
            //return apiReturn(c, false, "Error in setting the user access", error, 400);
            return c.json({success: false, message: "Error in closing connection", data: error}, 400);
        }
    }
);
export default app;
